#!/usr/bin/perl
use strict;
use warnings;

my $CHARS_PER_LINE = 75;
my $options = "";
my $dir = "";

for(@ARGV){
	if(/^-/){
		$options .= $_;
	}else{
		$dir = "\"".$_."\"";
	}
}
$options =~ s/-//g;

my $str = `dir $dir`;
my @files = split("\n",$str);
@files = @files[5..$#files-2];

if($options =~ "l"){
	print join "\n",@files;
}else{
	my @files2;
	my $maxlen = 1;
	for(@files){
		unless(/\.(\.)?$/){
			my @tmp;
			@tmp = split(/ +/,$_);
			$tmp[3] = join " ",@tmp[3..$#tmp];
			if($tmp[2] eq "<DIR>"){
				$tmp[3] = $tmp[3]."/";
			}
			$maxlen = length($tmp[3]) > $maxlen ? length($tmp[3]) : $maxlen;
			push @files2,$tmp[3];
		}
	}
	$maxlen += 2;
	if($maxlen > $CHARS_PER_LINE){
		print join "\n",@files2;
	}else{
		my $colums = int($CHARS_PER_LINE / $maxlen);
		my $i = 0;
		for(@files2){
			printf("%-${maxlen}s",$_);
			if(++$i % $colums == 0){
				print "\n";
			}
		}
	}
}
